/* test.js (C) 2013-2014 SheetJS -- http://sheetjs.com */
/* vim: set ts=2: */
function parsetest(x, wb, skip) {
	//describe(x + ' should have all bits', function() {
	//	it('should have all sheets', function() {
			wb.SheetNames.forEach(function(y) { if(!wb.Sheets[y]) throw new Error('bad sheet ' + y); });
	//	});
	//});
	//describe(x + ' should generate CSV', function() {
		wb.SheetNames.forEach(function(ws, i) {
			//it('#' + i + ' (' + ws + ')', function() {
				(x.substr(-1)=="s"?XLS:XLSX).utils.make_csv(wb.Sheets[ws]);
			//});
		});
	//});
	//describe(x + ' should generate JSON', function() {
		wb.SheetNames.forEach(function(ws, i) {
			//it('#' + i + ' (' + ws + ')', function() {
				(x.substr(-1)=="s"?XLS:XLSX).utils.sheet_to_row_object_array(wb.Sheets[ws]);
			//});
		});
	//});
	//describe(x + ' should generate formulae', function() {
		wb.SheetNames.forEach(function(ws, i) {
			//it('#' + i + ' (' + ws + ')', function() {
				(x.substr(-1)=="s"?XLS:XLSX).utils.get_formulae(wb.Sheets[ws]);
			//});
		});
	//});
	if(skip) return;
	describe(x + ' should round-trip XLSX', function() {
		//it('should have all sheets', function() {
			var wbxlsx = XLSX.read(XLSX.write(wb, {type:'binary', bookType:'xlsx', bookSST:true}), {type:'binary'});
			wbxlsx.SheetNames.forEach(function(y) { if(!wb.Sheets[y]) throw new Error('bad sheet ' + y); });
		//});
		//describe(x + ' should generate CSV', function() {
			var wbxlsm = XLSX.read(XLSX.write(wb, {type:'binary', bookType:'xlsm', bookSST:false}), {type:'binary'});
			wbxlsm.SheetNames.forEach(function(ws, i) {
				//it('#' + i + ' (' + ws + ')', function() {
					(x.substr(-1)=="s"?XLS:XLSX).utils.make_csv(wb.Sheets[ws]);
				//});
			});
		//});
		['xlsb', /*'ods', 'fods',*/ 'biff2'].forEach(function(bt) {
			XLSX.read(XLSX.write(wb, {type:'binary', bookType:bt}), {type:'binary'});
		});
	});
}

describe('should parse test files', function() {
	this.timeout(20000);
	[
"AutoFilter.xml",
"BlankSheetTypes.xml",
"LONumbers-2010.xls.xml",
"LONumbers-2010.xlsx.xml",
"LONumbers-2011.xls.xml",
"LONumbers-2011.xlsx.xml",
"LONumbers.xls.xml",
"NumberFormatCondition.xml",
"RkNumber.xls.xml",
"RkNumber.xlsb.xml",
"RkNumber.xlsx.xml",
"comments_stress_test.xls.xml",
"comments_stress_test.xlsb.xml",
"comments_stress_test.xlsx.xml",
"custom_properties.xls.xml",
"custom_properties.xlsb.xml",
"custom_properties.xlsx.xml",
"formula_stress_test.xls.xml",
"formula_stress_test.xlsb.xml",
"formula_stress_test.xlsx.xml",
"interview.xlsx.xml",
"issue.xlsx.xml",
"large_strings.xls.xml.pending",
"large_strings.xlsb.xml.pending",
"large_strings.xlsx.xml.pending",
"merge_cells.xls.xml",
"merge_cells.xlsb.xml",
"merge_cells.xlsx.xml",
"mixed_sheets.xlsx.xml",
"named_ranges_2011.xls.xml",
"named_ranges_2011.xlsb.xml",
"named_ranges_2011.xlsx.xml",
"number_format.xls.xml",
"number_format.xlsb.xml",
"number_format.xlsm.xml",
"oo34xml_cell_pattern.xml",
"oo34xml_cellstyle.xml",
"oo34xml_conditionalformat.xml",
"oo34xml_dataformat.xml",
"oo34xml_dataformat2.xml",
"oo34xml_datarange.xml",
"oo34xml_font.xml",
"oo34xml_formula.xml",
"oo34xml_headerfooter.xml",
"oo34xml_merge.xml",
"oo34xml_pagebreak.xml",
"oo34xml_pagesheet.xml",
"oo34xml_rowcolumn.xml",
"oo34xml_solvsamp.xml",
"pivot_table_named_range.xml",
"protect_stress_test_xml.xml",
"rich_text_stress.xls.xml",
"rich_text_stress.xlsb.xml",
"rich_text_stress.xlsx.xml",
"roo_Bibelbund.xml.pending",
"roo_bbu.xml",
"roo_boolean.xml",
"roo_borders.xml",
"roo_bug-row-column-fixnum-float.xml",
"roo_datetime.xml",
"roo_datetime_floatconv.xml",
"roo_emptysheets.xml",
"roo_excel2003.xml.pending",
"roo_false_encoding.xml",
"roo_formula.xml",
"roo_formula_parse_error.xml",
"roo_numbers1.xml",
"roo_only_one_sheet.xml",
"roo_paragraph.xml",
"roo_simple_spreadsheet.xml",
"roo_simple_spreadsheet_from_italo.xml",
"roo_style.xml",
"roo_time-test.xml",
"roo_whitespace.xml",
"xlsx-stream-d-date-cell.xls.xml",
"xlsx-stream-d-date-cell.xlsb.xml",
"xlsx-stream-d-date-cell.xlsx.xml",
"LONumbers-2010.xls",
"LONumbers-2011.xls",
"LONumbers.xls",
"NumberFormatCondition.xls",
"RkNumber.xls",
"apachepoi_12561-1.xls",
"apachepoi_12561-2.xls",
"apachepoi_12843-1.xls.pending", /* too slow */
"apachepoi_12843-2.xls",
"apachepoi_13224.xls",
"apachepoi_13796.xls",
"apachepoi_14330-1.xls",
"apachepoi_14330-2.xls",
"apachepoi_14460.xls",
"apachepoi_15228.xls.pending", /* too slow */
"apachepoi_15375.xls",
"apachepoi_15556.xls.pending", /* too slow */
"apachepoi_15573.xls",
"apachepoi_1900DateWindowing.xls",
"apachepoi_1904DateWindowing.xls",
"apachepoi_19599-1.xls",
"apachepoi_19599-2.xls",
"apachepoi_22742.xls",
"apachepoi_24207.xls",
"apachepoi_24215.xls",
"apachepoi_25183.xls",
"apachepoi_25695.xls",
"apachepoi_26100.xls",
"apachepoi_27272_1.xls",
"apachepoi_27272_2.xls",
"apachepoi_27349-vlookupAcrossSheets.xls",
"apachepoi_27364.xls",
"apachepoi_27394.xls",
"apachepoi_27852.xls",
"apachepoi_27933.xls",
"apachepoi_28772.xls",
"apachepoi_28774.xls",
"apachepoi_29675.xls",
"apachepoi_29942.xls",
"apachepoi_29982.xls.pending", /* too slow */
"apachepoi_30070.xls",
"apachepoi_30540.xls",
"apachepoi_30978-alt.xls",
"apachepoi_30978-deleted.xls",
"apachepoi_31661.xls",
"apachepoi_31749.xls.pending", /* too slow */
"apachepoi_31979.xls",
"apachepoi_32822.xls",
"apachepoi_33082.xls",
"apachepoi_34775.xls",
"apachepoi_35564.xls",
"apachepoi_35565.xls",
"apachepoi_36947.xls",
"apachepoi_37376.xls",
"apachepoi_37630.xls",
"apachepoi_37684-1.xls",
"apachepoi_37684-2.xls",
"apachepoi_37684.xls",
"apachepoi_39234.xls",
"apachepoi_39512.xls",
"apachepoi_39634.xls",
"apachepoi_3dFormulas.xls",
"apachepoi_40285.xls",
"apachepoi_41139.xls",
"apachepoi_41546.xls",
"apachepoi_42464-ExpPtg-bad.xls",
"apachepoi_42464-ExpPtg-ok.xls",
"apachepoi_42726.xls",
"apachepoi_42844.xls",
"apachepoi_43251.xls",
"apachepoi_43493.xls",
"apachepoi_43623.xls",
"apachepoi_43902.xls",
"apachepoi_44010-SingleChart.xls",
"apachepoi_44010-TwoCharts.xls",
"apachepoi_44167.xls",
"apachepoi_44200.xls",
"apachepoi_44201.xls",
"apachepoi_44235.xls",
"apachepoi_44297.xls",
"apachepoi_44593.xls.pending", /* too large */
"apachepoi_44636.xls",
"apachepoi_44643.xls",
"apachepoi_44693.xls",
"apachepoi_44840.xls",
"apachepoi_44861.xls",
"apachepoi_44891.xls.pending", /* too slow */
"apachepoi_44958.xls",
"apachepoi_45129.xls",
"apachepoi_45290.xls",
"apachepoi_45322.xls",
"apachepoi_45365-2.xls.pending", /* too slow */
"apachepoi_45365.xls",
"apachepoi_45492.xls",
"apachepoi_45538_classic_Footer.xls",
"apachepoi_45538_classic_Header.xls",
"apachepoi_45538_form_Footer.xls",
"apachepoi_45538_form_Header.xls",
"apachepoi_45672.xls",
"apachepoi_45720.xls",
"apachepoi_45761.xls",
"apachepoi_45784.xls",
"apachepoi_46136-NoWarnings.xls",
"apachepoi_46136-WithWarnings.xls",
"apachepoi_46137.xls",
"apachepoi_46250.xls",
//"apachepoi_46368.xls", // safari max call stack size exceeded
"apachepoi_46445.xls",
"apachepoi_46904.xls.pending", /* too large */
"apachepoi_47034.xls.pending", /* too slow */
"apachepoi_47154.xls",
"apachepoi_47251.xls",
"apachepoi_47701.xls",
"apachepoi_47847.xls",
"apachepoi_47920.xls",
"apachepoi_47924.xls",
"apachepoi_48026.xls",
"apachepoi_48180.xls",
"apachepoi_48325.xls",
"apachepoi_48703.xls",
"apachepoi_48968.xls",
"apachepoi_49096.xls",
"apachepoi_49185.xls",
"apachepoi_49219.xls",
"apachepoi_49237.xls",
"apachepoi_49524.xls",
"apachepoi_49529.xls",
"apachepoi_49581.xls",
"apachepoi_49612.xls",
"apachepoi_49751.xls",
"apachepoi_49761.xls",
"apachepoi_49896.xls",
"apachepoi_49928.xls",
"apachepoi_49931.xls",
"apachepoi_50020.xls",
"apachepoi_50298.xls",
"apachepoi_50426.xls",
"apachepoi_50756.xls",
"apachepoi_50779_1.xls",
"apachepoi_50779_2.xls",
"apachepoi_50833.xls.pending", /* password */
"apachepoi_50939.xls",
"apachepoi_51143.xls",
"apachepoi_51461.xls",
"apachepoi_51498.xls",
//"apachepoi_51535.xls",
"apachepoi_51670.xls",
"apachepoi_51675.xls",
"apachepoi_51832.xls.pending", /* password */
"apachepoi_52527.xls",
"apachepoi_52575_main.xls",
"apachepoi_52575_source.xls",
"apachepoi_53404.xls",
"apachepoi_53446.xls.pending", /* too large */
"apachepoi_53588.xls",
"apachepoi_53798_shiftNegative_TMPL.xls",
"apachepoi_53972.xls",
"apachepoi_54016.xls.pending", /* too slow */
"apachepoi_54206.xls",
"apachepoi_54500.xls",
"apachepoi_54686_fraction_formats.xls.pending", /* too slow */
"apachepoi_55341_CellStyleBorder.xls",
"apachepoi_AbnormalSharedFormulaFlag.xls",
"apachepoi_AreaErrPtg.xls",
//"apachepoi_BOOK_in_capitals.xls",
"apachepoi_CodeFunctionTestCaseData.xls",
"apachepoi_ColumnStyle1dp.xls",
"apachepoi_ColumnStyle1dpColoured.xls",
"apachepoi_ColumnStyleNone.xls",
"apachepoi_ComplexFunctionTestCaseData.xls",
"apachepoi_ContinueRecordProblem.xls",
"apachepoi_DBCSHeader.xls",
"apachepoi_DBCSSheetName.xls",
"apachepoi_DateFormats.xls",
"apachepoi_DeltaFunctionTestCaseData.xls",
"apachepoi_DrawingAndComments.xls",
"apachepoi_DrawingContinue.xls",
"apachepoi_EmbeddedChartHeaderTest.xls",
"apachepoi_Employee.xls",
"apachepoi_ErrPtg.xls",
"apachepoi_FactDoubleFunctionTestCaseData.xls",
"apachepoi_ForShifting.xls",
"apachepoi_FormatChoiceTests.xls",
"apachepoi_Formatting.xls",
"apachepoi_FormulaEvalTestData.xls",
"apachepoi_FormulaRefs.xls",
"apachepoi_HyperlinksOnManySheets.xls",
"apachepoi_IfFormulaTest.xls",
"apachepoi_ImRealFunctionTestCaseData.xls",
"apachepoi_ImaginaryFunctionTestCaseData.xls",
"apachepoi_IndexFunctionTestCaseData.xls",
"apachepoi_IndirectFunctionTestCaseData.xls",
"apachepoi_IntersectionPtg.xls",
"apachepoi_IrrNpvTestCaseData.xls",
"apachepoi_LookupFunctionsTestCaseData.xls",
"apachepoi_MRExtraLines.xls",
"apachepoi_MatchFunctionTestCaseData.xls",
"apachepoi_MissingBits.xls",
"apachepoi_NoGutsRecords.xls",
"apachepoi_OddStyleRecord.xls",
"apachepoi_PercentPtg.xls",
"apachepoi_QuotientFunctionTestCaseData.xls",
"apachepoi_RangePtg.xls",
"apachepoi_ReadOnlyRecommended.xls",
//"apachepoi_ReferencePtg.xls",
"apachepoi_RepeatingRowsCols.xls",
"apachepoi_ReptFunctionTestCaseData.xls",
"apachepoi_RomanFunctionTestCaseData.xls",
"apachepoi_SampleSS.xls",
//"apachepoi_SharedFormulaTest.xls",
"apachepoi_SheetWithDrawing.xls",
"apachepoi_ShrinkToFit.xls",
"apachepoi_Simple.xls",
"apachepoi_SimpleChart.xls",
"apachepoi_SimpleMultiCell.xls",
"apachepoi_SimpleWithAutofilter.xls",
"apachepoi_SimpleWithChoose.xls",
"apachepoi_SimpleWithColours.xls",
"apachepoi_SimpleWithComments.xls",
"apachepoi_SimpleWithDataFormat.xls",
"apachepoi_SimpleWithFormula.xls",
"apachepoi_SimpleWithImages-mac.xls",
"apachepoi_SimpleWithImages.xls",
"apachepoi_SimpleWithPageBreaks.xls",
"apachepoi_SimpleWithPrintArea.xls",
"apachepoi_SimpleWithSkip.xls",
"apachepoi_SimpleWithStyling.xls",
"apachepoi_SingleLetterRanges.xls",
"apachepoi_SolverContainerAfterSPGR.xls",
"apachepoi_SquareMacro.xls",
"apachepoi_StringContinueRecords.xls.pending", /* too slow */
"apachepoi_StringFormulas.xls",
"apachepoi_SubtotalsNested.xls",
"apachepoi_TestRandBetween.xls",
"apachepoi_TwoSheetsNoneHidden.xls",
"apachepoi_TwoSheetsOneHidden.xls",
"apachepoi_UncalcedRecord.xls",
"apachepoi_UnionPtg.xls",
"apachepoi_WORKBOOK_in_capitals.xls",
"apachepoi_WeekNumFunctionTestCaseData.xls",
"apachepoi_WeekNumFunctionTestCaseData2013.xls",
"apachepoi_WithChart.xls",
"apachepoi_WithCheckBoxes.xls",
"apachepoi_WithConditionalFormatting.xls",
"apachepoi_WithEmbeddedObjects.xls",
"apachepoi_WithExtendedStyles.xls",
"apachepoi_WithFormattedGraphTitle.xls",
"apachepoi_WithHyperlink.xls",
"apachepoi_WithThreeCharts.xls",
"apachepoi_WithTwoCharts.xls",
"apachepoi_WithTwoHyperLinks.xls",
"apachepoi_WrongFormulaRecordType.xls",
"apachepoi_XRefCalc.xls",
"apachepoi_XRefCalcData.xls",
"apachepoi_atp.xls",
"apachepoi_blankworkbook.xls",
"apachepoi_bug_42794.xls",
"apachepoi_colwidth.xls",
"apachepoi_comments.xls",
"apachepoi_countblankExamples.xls",
"apachepoi_countifExamples.xls",
"apachepoi_dg-text.xls",
"apachepoi_drawings.xls.pending", /* too slow */
"apachepoi_duprich1.xls",
"apachepoi_duprich2.xls",
"apachepoi_dvEmpty.xls",
"apachepoi_empty.xls",
"apachepoi_ex41187-19267.xls",
"apachepoi_ex42564-21435.xls",
"apachepoi_ex42564-21503.xls",
"apachepoi_ex42564-elementOrder.xls",
"apachepoi_ex42570-20305.xls.pending", /* too slow * /* too slow */
"apachepoi_ex44921-21902.xls",
"apachepoi_ex45046-21984.xls",
"apachepoi_ex45582-22397.xls",
"apachepoi_ex45672.xls",
"apachepoi_ex45698-22488.xls.pending", /* too large */
"apachepoi_ex45978-extraLinkTableSheets.xls",
"apachepoi_ex46548-23133.xls",
"apachepoi_ex47747-sharedFormula.xls",
"apachepoi_excel_with_embeded.xls",
"apachepoi_excelant.xls",
"apachepoi_externalFunctionExample.xls",
"apachepoi_finance.xls",
"apachepoi_intercept.xls",
"apachepoi_mirrTest.xls",
"apachepoi_missingFuncs44675.xls",
"apachepoi_mortgage-calculation.xls",
"apachepoi_multibookFormulaA.xls",
"apachepoi_multibookFormulaB.xls",
"apachepoi_namedinput.xls",
"apachepoi_noHeaderFooter47244.xls",
"apachepoi_ole2-embedding.xls",
"apachepoi_overlapSharedFormula.xls",
"apachepoi_password.xls.pending", /* password */
"apachepoi_rank.xls",
"apachepoi_rk.xls",
"apachepoi_shared_formulas.xls",
"apachepoi_sumifformula.xls",
"apachepoi_sumifs.xls",
"apachepoi_templateExcelWithAutofilter.xls",
"apachepoi_testArraysAndTables.xls",
"apachepoi_testNames.xls",
"apachepoi_testRRaC.xls",
"apachepoi_testRVA.xls",
"apachepoi_text.xls",
"apachepoi_unicodeNameRecord.xls",
"apachepoi_xor-encryption-abc.xls.pending", /* password */
"apachepoi_yearfracExamples.xls",
"comments_stress_test.xls",
"custom_properties.xls",
"formula_stress_test.xls",
"fraction-test.xls.pending", /* too slow */
"jxls-core_array.xls",
"jxls-core_beandata.xls",
"jxls-core_beanwithlist.xls",
"jxls-core_doubleForEachOneRow.xls",
"jxls-core_dynamicColumns.xls",
"jxls-core_employeeNotes.xls",
"jxls-core_expressions1.xls",
"jxls-core_fixedsizelist.xls",
"jxls-core_forOneRow.xls",
"jxls-core_forOneRowMerge.xls",
"jxls-core_forOneRowMerge2.xls",
"jxls-core_forgroup.xls",
"jxls-core_foriftag2.xls",
"jxls-core_foriftag3.xls",
"jxls-core_foriftag3OutTag.xls",
"jxls-core_foriftagHor.xls",
"jxls-core_foriftagOneRow.xls",
"jxls-core_foriftagOneRow2.xls",
"jxls-core_foriftagmerge.xls",
"jxls-core_formatterbean.xls",
"jxls-core_formula3.xls",
"jxls-core_formula4.xls",
"jxls-core_formulas.xls",
"jxls-core_formulas2.xls",
"jxls-core_grouping1.xls",
"jxls-core_grouping2.xls",
"jxls-core_grouping3.xls",
"jxls-core_grouping4.xls",
"jxls-core_groupingformulas.xls",
"jxls-core_grouptag.xls",
"jxls-core_hidesheets.xls",
"jxls-core_iftag.xls",
"jxls-core_iftagempty.xls",
"jxls-core_jexl.xls",
"jxls-core_mergecellslist.xls",
"jxls-core_mergemultiplelistrows.xls",
"jxls-core_multi-tab-template.xls",
"jxls-core_multipleSheetList.xls",
"jxls-core_multiplelistrows.xls",
"jxls-core_outline.xls",
"jxls-core_outtaginonerow.xls",
"jxls-core_paralleltables.xls",
"jxls-core_poiobjects.xls",
"jxls-core_repeatedFormula.xls",
"jxls-core_report.xls",
"jxls-core_reportTimestamp.xls",
"jxls-core_select.xls",
"jxls-core_select2.xls",
"jxls-core_severallistsinrow.xls",
"jxls-core_severalpropertiesincell.xls",
"jxls-core_simplebean.xls",
"jxls-core_sqltagreport.xls",
"jxls-core_stress.xls",
"jxls-core_syntaxerror.xls",
"jxls-core_twoIfTagsIn1Row.xls",
"jxls-core_varstatus.xls",
"jxls-examples_adjacentlists.xls",
"jxls-examples_basictags.xls",
"jxls-examples_chart.xls",
"jxls-examples_colouring.xls",
"jxls-examples_department.xls",
"jxls-examples_dynamicolumns.xls",
"jxls-examples_employees.xls",
"jxls-examples_ex_temp.xls",
"jxls-examples_grouping.xls",
"jxls-examples_multiplelistrows.xls",
"jxls-examples_report.xls",
"jxls-examples_rowstyle.xls",
"jxls-examples_stress1.xls",
"jxls-examples_stress2.xls",
"jxls-reader_departmentData.xls",
"jxls-reader_employeesData.xls",
"jxls-reader_emptyrowdata.xls",
"jxls-reader_error1.xls",
"jxls-reader_formulasData.xls",
"jxls-reader_ids.xls",
"jxls-src_adjacentlist_output.xls",
"jxls-src_adjacentlists.xls",
"jxls-src_basictags.xls",
"jxls-src_basictags_output.xls",
"jxls-src_chart.xls",
"jxls-src_chart_output.xls",
"jxls-src_colouring.xls",
"jxls-src_colouring_output.xls",
"jxls-src_department.xls",
"jxls-src_department_output.xls",
"jxls-src_departmentdata.xls",
"jxls-src_dynamiccolumns_output.xls",
"jxls-src_dynamiccolumns_template.xls",
"jxls-src_employees.xls",
"jxls-src_employees_output.xls",
"jxls-src_grouping.xls",
"jxls-src_grouping_output.xls",
"jxls-src_hiddencolumn_output.xls",
"jxls-src_multiplelistrows.xls",
"jxls-src_multiplelistrows_output.xls",
"jxls-src_report.xls",
"jxls-src_report_output.xls",
"jxls-src_rowstyle.xls",
"jxls-src_rowstyle_output.xls",
"large_strings.xls.pending", /* too large */
"merge_cells.xls",
"named_ranges_2011.xls",
"number_format.xls",
"pivot_table_named_range.xls",
"pivot_table_test.xls",
"pyExcelerator_P-0508-0000507647-3280-5298.xls",
"pyExcelerator_chart1v8.xls",
"pyExcelerator_excel2003.xls",
"pyExcelerator_frmla.xls",
"pyExcelerator_macro2v8.xls",
"pyExcelerator_mini-mini.xls",
"pyExcelerator_mini.xls",
"pyExcelerator_oo14.xls",
"rich_text_stress.xls",
"roo_1900_base.xls",
"roo_1904_base.xls",
"roo_Bibelbund.xls.pending", /* too slow */
"roo_bad_excel_date.xls",
"roo_bbu.xls",
"roo_boolean.xls",
"roo_borders.xls",
"roo_bug-row-column-fixnum-float.xls",
"roo_comments.xls",
"roo_datetime.xls",
"roo_datetime_floatconv.xls",
"roo_emptysheets.xls",
"roo_false_encoding.xls",
"roo_formula.xls",
"roo_formula_parse_error.xls",
"roo_link.xls",
"roo_matrix.xls",
"roo_named_cells.xls",
"roo_numbers1.xls",
"roo_only_one_sheet.xls",
"roo_paragraph.xls",
"roo_prova.xls",
"roo_simple_spreadsheet.xls",
"roo_simple_spreadsheet_from_italo.xls",
"roo_style.xls",
"roo_time-test.xls",
"roo_type_excelx.xls.pending", /* not xls */
"roo_type_openoffice.xls.pending", /* not xls */
"roo_whitespace.xls",
"xlrd_Formate.xls",
"xlrd_formula_test_names.xls",
"xlrd_formula_test_sjmachin.xls",
"xlrd_issue20.xls",
"xlrd_picture_in_cell.xls",
"xlrd_profiles.xls",
"xlrd_ragged.xls",
"xlrd_xf_class.xls",
"xlsx-stream-d-date-cell.xls",
"AutoFilter.xlsb",
//"BlankSheetTypes.xlsb",
"NumberFormatCondition.xlsb",
"RkNumber.xlsb",
"apachepoi_12561-1.xls.xlsb",
"apachepoi_12561-2.xls.xlsb",
//"apachepoi_12843-1.xls.xlsb",
"apachepoi_12843-2.xls.xlsb",
"apachepoi_13224.xls.xlsb",
"apachepoi_13796.xls.xlsb",
"apachepoi_14330-1.xls.xlsb",
"apachepoi_14330-2.xls.xlsb",
"apachepoi_14460.xls.xlsb",
//"apachepoi_15228.xls.xlsb",
"apachepoi_15375.xls.xlsb",
"apachepoi_15556.xls.xlsb",
"apachepoi_15573.xls.xlsb",
"apachepoi_1900DateWindowing.xls.xlsb",
"apachepoi_1904DateWindowing.xls.xlsb",
"apachepoi_19599-1.xls.xlsb",
"apachepoi_19599-2.xls.xlsb",
"apachepoi_22742.xls.xlsb",
"apachepoi_24207.xls.xlsb",
"apachepoi_24215.xls.xlsb",
"apachepoi_25183.xls.xlsb",
"apachepoi_25695.xls.xlsb",
"apachepoi_26100.xls.xlsb",
"apachepoi_27272_1.xls.xlsb",
"apachepoi_27272_2.xls.xlsb",
"apachepoi_27349-vlookupAcrossSheets.xls.xlsb",
"apachepoi_27364.xls.xlsb",
"apachepoi_27394.xls.xlsb",
"apachepoi_27852.xls.xlsb",
"apachepoi_27933.xls.xlsb",
"apachepoi_28772.xls.xlsb",
"apachepoi_28774.xls.xlsb",
"apachepoi_29675.xls.xlsb",
"apachepoi_29942.xls.xlsb",
"apachepoi_29982.xls.xlsb",
"apachepoi_30070.xls.xlsb",
"apachepoi_30540.xls.xlsb",
"apachepoi_30978-alt.xls.xlsb",
"apachepoi_30978-deleted.xls.xlsb",
"apachepoi_31661.xls.xlsb",
"apachepoi_31749.xls.xlsb",
"apachepoi_31979.xls.xlsb",
"apachepoi_32822.xls.xlsb",
"apachepoi_33082.xls.xlsb",
//"apachepoi_34775.xls.xlsb",
"apachepoi_35564.xls.xlsb",
"apachepoi_35565.xls.xlsb",
"apachepoi_36947.xls.xlsb",
"apachepoi_37376.xls.xlsb",
"apachepoi_37630.xls.xlsb",
"apachepoi_37684-1.xls.xlsb",
"apachepoi_37684-2.xls.xlsb",
"apachepoi_37684.xls.xlsb",
"apachepoi_39234.xls.xlsb",
"apachepoi_39512.xls.xlsb",
"apachepoi_39634.xls.xlsb",
"apachepoi_3dFormulas.xls.xlsb",
"apachepoi_40285.xls.xlsb",
"apachepoi_41139.xls.xlsb",
"apachepoi_41546.xls.xlsb",
"apachepoi_42464-ExpPtg-bad.xls.xlsb",
"apachepoi_42464-ExpPtg-ok.xls.xlsb",
"apachepoi_42726.xls.xlsb",
"apachepoi_42844.xls.xlsb",
"apachepoi_43251.xls.xlsb",
"apachepoi_43623.xls.xlsb",
"apachepoi_43902.xls.xlsb",
//"apachepoi_44010-SingleChart.xls.xlsb",
//"apachepoi_44010-TwoCharts.xls.xlsb",
"apachepoi_44167.xls.xlsb",
"apachepoi_44200.xls.xlsb",
"apachepoi_44201.xls.xlsb",
"apachepoi_44235.xls.xlsb",
"apachepoi_44297.xls.xlsb",
"apachepoi_44593.xls.xlsb.pending",
"apachepoi_44636.xls.xlsb",
"apachepoi_44643.xls.xlsb",
"apachepoi_44693.xls.xlsb",
"apachepoi_44840.xls.xlsb",
"apachepoi_44861.xls.xlsb",
//"apachepoi_44891.xls.xlsb",
"apachepoi_44958.xls.xlsb",
"apachepoi_45129.xls.xlsb",
"apachepoi_45290.xls.xlsb",
"apachepoi_45322.xls.xlsb",
"apachepoi_45365-2.xls.xlsb",
"apachepoi_45365.xls.xlsb",
"apachepoi_45430.xlsx.xlsb",
"apachepoi_45431.xlsm.xlsb",
"apachepoi_45492.xls.xlsb",
"apachepoi_45538_classic_Footer.xls.xlsb",
"apachepoi_45538_classic_Header.xls.xlsb",
"apachepoi_45538_form_Footer.xls.xlsb",
"apachepoi_45538_form_Header.xls.xlsb",
"apachepoi_45540_classic_Footer.xlsx.xlsb",
"apachepoi_45540_classic_Header.xlsx.xlsb",
"apachepoi_45540_form_Footer.xlsx.xlsb",
"apachepoi_45540_form_Header.xlsx.xlsb",
"apachepoi_45544.xlsx.xlsb",
"apachepoi_45672.xls.xlsb",
"apachepoi_45720.xls.xlsb",
"apachepoi_45761.xls.xlsb",
"apachepoi_45784.xls.xlsb",
"apachepoi_46136-NoWarnings.xls.xlsb",
"apachepoi_46136-WithWarnings.xls.xlsb",
"apachepoi_46137.xls.xlsb",
"apachepoi_46250.xls.xlsb",
"apachepoi_46445.xls.xlsb",
"apachepoi_46535.xlsx.xlsb",
"apachepoi_46536.xlsx.xlsb",
"apachepoi_47026.xlsm.xlsb",
"apachepoi_47034.xls.xlsb",
"apachepoi_47089.xlsm.xlsb",
"apachepoi_47090.xlsx.xlsb",
"apachepoi_47154.xls.xlsb",
"apachepoi_47251.xls.xlsb",
"apachepoi_47504.xlsx.xlsb",
"apachepoi_47668.xlsx.xlsb",
"apachepoi_47701.xls.xlsb",
"apachepoi_47737.xlsx.xlsb",
//"apachepoi_47804.xlsx.xlsb",
//"apachepoi_47813.xlsx.xlsb",
"apachepoi_47847.xls.xlsb",
"apachepoi_47862.xlsx.xlsb",
"apachepoi_47889.xlsx.xlsb",
"apachepoi_47920.xls.xlsb",
"apachepoi_47924.xls.xlsb",
"apachepoi_48026.xls.xlsb",
"apachepoi_48180.xls.xlsb",
"apachepoi_48325.xls.xlsb",
"apachepoi_48495.xlsx.xlsb",
"apachepoi_48539.xlsx.xlsb",
"apachepoi_48703.xls.xlsb",
"apachepoi_48703.xlsx.xlsb",
"apachepoi_48779.xlsx.xlsb",
"apachepoi_48923.xlsx.xlsb",
"apachepoi_48968.xls.xlsb",
"apachepoi_49096.xls.xlsb",
//"apachepoi_49156.xlsx.xlsb",
"apachepoi_49185.xls.xlsb",
"apachepoi_49219.xls.xlsb",
"apachepoi_49237.xls.xlsb",
"apachepoi_49273.xlsx.xlsb",
"apachepoi_49325.xlsx.xlsb",
"apachepoi_49524.xls.xlsb",
"apachepoi_49529.xls.xlsb",
"apachepoi_49581.xls.xlsb",
"apachepoi_49609.xlsx.xlsb",
"apachepoi_49612.xls.xlsb",
"apachepoi_49751.xls.xlsb",
"apachepoi_49761.xls.xlsb",
"apachepoi_49783.xlsx.xlsb",
"apachepoi_49872.xlsx.xlsb",
"apachepoi_49896.xls.xlsb",
"apachepoi_49928.xls.xlsb",
"apachepoi_49928.xlsx.xlsb",
"apachepoi_49931.xls.xlsb",
"apachepoi_49966.xlsx.xlsb",
"apachepoi_50020.xls.xlsb",
"apachepoi_50096.xlsx.xlsb",
"apachepoi_50298.xls.xlsb",
"apachepoi_50299.xlsx.xlsb",
"apachepoi_50426.xls.xlsb",
"apachepoi_50756.xls.xlsb",
"apachepoi_50779_1.xls.xlsb",
"apachepoi_50779_2.xls.xlsb",
"apachepoi_50784-font_theme_colours.xlsx.xlsb",
"apachepoi_50786-indexed_colours.xlsx.xlsb",
"apachepoi_50795.xlsx.xlsb",
"apachepoi_50833.xls.xlsb",
"apachepoi_50846-border_colours.xlsx.xlsb",
"apachepoi_50867_with_table.xlsx.xlsb",
"apachepoi_50939.xls.xlsb",
"apachepoi_51143.xls.xlsb",
"apachepoi_51222.xlsx.xlsb",
"apachepoi_51461.xls.xlsb",
"apachepoi_51470.xlsx.xlsb",
"apachepoi_51498.xls.xlsb",
//"apachepoi_51535.xls.xlsb",
"apachepoi_51585.xlsx.xlsb",
"apachepoi_51670.xls.xlsb",
"apachepoi_51675.xls.xlsb",
"apachepoi_51710.xlsx.xlsb",
"apachepoi_51850.xlsx.xlsb",
"apachepoi_51963.xlsx.xlsb",
"apachepoi_52348.xlsx.xlsb",
"apachepoi_52527.xls.xlsb",
"apachepoi_52575_main.xls.xlsb",
"apachepoi_52575_source.xls.xlsb",
"apachepoi_52716.xlsx.xlsb",
"apachepoi_53101.xlsx.xlsb",
"apachepoi_53282.xlsx.xlsb",
"apachepoi_53282b.xlsx.xlsb",
"apachepoi_53404.xls.xlsb",
"apachepoi_53446.xls.xlsb.pending",
"apachepoi_53568.xlsx.xlsb",
"apachepoi_53588.xls.xlsb",
"apachepoi_53734.xlsx.xlsb",
"apachepoi_53798.xlsx.xlsb",
"apachepoi_53798_shiftNegative_TMPL.xls.xlsb",
"apachepoi_53798_shiftNegative_TMPL.xlsx.xlsb",
"apachepoi_53972.xls.xlsb",
"apachepoi_54016.xls.xlsb",
"apachepoi_54071.xlsx.xlsb",
"apachepoi_54084 - Greek - beyond BMP.xlsx.xlsb",
//"apachepoi_54206.xls.xlsb",
//"apachepoi_54206.xlsx.xlsb",
"apachepoi_54288-ref.xlsx.xlsb",
"apachepoi_54288.xlsx.xlsb",
"apachepoi_54436.xlsx.xlsb",
"apachepoi_54500.xls.xlsb",
"apachepoi_54524.xlsx.xlsb",
"apachepoi_54607.xlsx.xlsb",
"apachepoi_54686_fraction_formats.xls.xlsb",
"apachepoi_55341_CellStyleBorder.xls.xlsb",
"apachepoi_55640.xlsx.xlsb",
"apachepoi_55745.xlsx.xlsb",
"apachepoi_55850.xlsx.xlsb",
"apachepoi_55923.xlsx.xlsb",
"apachepoi_55924.xlsx.xlsb",
"apachepoi_55926.xlsx.xlsb",
"apachepoi_55927.xlsx.xlsb",
"apachepoi_56011.xlsx.xlsb",
"apachepoi_56017.xlsx.xlsb",
"apachepoi_AbnormalSharedFormulaFlag.xls.xlsb",
//"apachepoi_AreaErrPtg.xls.xlsb",
"apachepoi_AverageTaxRates.xlsx.xlsb",
"apachepoi_BOOK_in_capitals.xls.xlsb",
"apachepoi_Booleans.xlsx.xlsb",
"apachepoi_BrNotClosed.xlsx.xlsb",
"apachepoi_CodeFunctionTestCaseData.xls.xlsb",
"apachepoi_ColumnStyle1dp.xls.xlsb",
"apachepoi_ColumnStyle1dpColoured.xls.xlsb",
"apachepoi_ColumnStyleNone.xls.xlsb",
"apachepoi_ComplexFunctionTestCaseData.xls.xlsb",
"apachepoi_ContinueRecordProblem.xls.xlsb",
"apachepoi_CustomXMLMapping-singleattributenamespace.xlsx.xlsb",
"apachepoi_CustomXMLMappings-complex-type.xlsx.xlsb",
"apachepoi_CustomXMLMappings.xlsx.xlsb",
"apachepoi_CustomXmlMappings-inverse-order.xlsx.xlsb",
"apachepoi_DBCSHeader.xls.xlsb",
"apachepoi_DBCSSheetName.xls.xlsb",
"apachepoi_DataValidations-49244.xlsx.xlsb",
"apachepoi_DateFormatTests.xlsx.xlsb",
"apachepoi_DateFormats.xls.xlsb",
"apachepoi_DeltaFunctionTestCaseData.xls.xlsb",
"apachepoi_DrawingAndComments.xls.xlsb",
"apachepoi_DrawingContinue.xls.xlsb",
"apachepoi_ElapsedFormatTests.xlsx.xlsb",
"apachepoi_EmbeddedChartHeaderTest.xls.xlsb",
"apachepoi_Employee.xls.xlsb",
"apachepoi_ErrPtg.xls.xlsb",
"apachepoi_ExcelWithAttachments.xlsm.xlsb",
"apachepoi_FactDoubleFunctionTestCaseData.xls.xlsb",
"apachepoi_ForShifting.xls.xlsb",
"apachepoi_ForShifting.xlsx.xlsb",
"apachepoi_FormatChoiceTests.xls.xlsb",
"apachepoi_FormatChoiceTests.xlsx.xlsb",
"apachepoi_FormatConditionTests.xlsx.xlsb",
"apachepoi_Formatting.xls.xlsb",
"apachepoi_Formatting.xlsx.xlsb",
//"apachepoi_FormulaEvalTestData.xls.xlsb",
//"apachepoi_FormulaEvalTestData_Copy.xlsx.xlsb",
"apachepoi_FormulaRefs.xls.xlsb",
"apachepoi_GeneralFormatTests.xlsx.xlsb",
"apachepoi_GroupTest.xlsx.xlsb",
"apachepoi_HyperlinksOnManySheets.xls.xlsb",
"apachepoi_IfFormulaTest.xls.xlsb",
"apachepoi_ImRealFunctionTestCaseData.xls.xlsb",
"apachepoi_ImaginaryFunctionTestCaseData.xls.xlsb",
"apachepoi_IndexFunctionTestCaseData.xls.xlsb",
"apachepoi_IndirectFunctionTestCaseData.xls.xlsb",
"apachepoi_InlineStrings.xlsx.xlsb",
"apachepoi_IntersectionPtg.xls.xlsb",
"apachepoi_IrrNpvTestCaseData.xls.xlsb",
//"apachepoi_LookupFunctionsTestCaseData.xls.xlsb",
"apachepoi_MRExtraLines.xls.xlsb",
"apachepoi_MatchFunctionTestCaseData.xls.xlsb",
"apachepoi_MissingBits.xls.xlsb",
"apachepoi_NewlineInFormulas.xlsx.xlsb",
"apachepoi_NoGutsRecords.xls.xlsb",
"apachepoi_NumberFormatApproxTests.xlsx.xlsb",
"apachepoi_NumberFormatTests.xlsx.xlsb",
"apachepoi_PercentPtg.xls.xlsb",
"apachepoi_QuotientFunctionTestCaseData.xls.xlsb",
"apachepoi_RangePtg.xls.xlsb",
"apachepoi_ReadOnlyRecommended.xls.xlsb",
//"apachepoi_ReferencePtg.xls.xlsb",
"apachepoi_RepeatingRowsCols.xls.xlsb",
"apachepoi_RepeatingRowsCols.xlsx.xlsb",
"apachepoi_ReptFunctionTestCaseData.xls.xlsb",
"apachepoi_RomanFunctionTestCaseData.xls.xlsb",
"apachepoi_SampleSS.xls.xlsb",
"apachepoi_SampleSS.xlsx.xlsb",
//"apachepoi_SharedFormulaTest.xls.xlsb",
"apachepoi_SheetWithDrawing.xls.xlsb",
"apachepoi_ShrinkToFit.xls.xlsb",
"apachepoi_ShrinkToFit.xlsx.xlsb",
"apachepoi_Simple.xls.xlsb",
"apachepoi_SimpleChart.xls.xlsb",
"apachepoi_SimpleMultiCell.xls.xlsb",
"apachepoi_SimpleMultiCell.xlsx.xlsb",
"apachepoi_SimpleWithAutofilter.xls.xlsb",
"apachepoi_SimpleWithChoose.xls.xlsb",
"apachepoi_SimpleWithColours.xls.xlsb",
"apachepoi_SimpleWithComments.xls.xlsb",
"apachepoi_SimpleWithComments.xlsx.xlsb",
"apachepoi_SimpleWithDataFormat.xls.xlsb",
"apachepoi_SimpleWithFormula.xls.xlsb",
"apachepoi_SimpleWithImages-mac.xls.xlsb",
"apachepoi_SimpleWithImages.xls.xlsb",
"apachepoi_SimpleWithPageBreaks.xls.xlsb",
"apachepoi_SimpleWithPrintArea.xls.xlsb",
"apachepoi_SimpleWithSkip.xls.xlsb",
"apachepoi_SimpleWithStyling.xls.xlsb",
"apachepoi_SingleLetterRanges.xls.xlsb",
"apachepoi_SolverContainerAfterSPGR.xls.xlsb",
"apachepoi_SquareMacro.xls.xlsb",
"apachepoi_StringContinueRecords.xls.xlsb",
"apachepoi_StringFormulas.xls.xlsb",
"apachepoi_SubtotalsNested.xls.xlsb",
"apachepoi_Tables.xlsx.xlsb",
"apachepoi_TestRandBetween.xls.xlsb",
"apachepoi_TextFormatTests.xlsx.xlsb",
"apachepoi_TwoSheetsNoneHidden.xls.xlsb",
"apachepoi_TwoSheetsNoneHidden.xlsx.xlsb",
"apachepoi_TwoSheetsOneHidden.xls.xlsb",
"apachepoi_TwoSheetsOneHidden.xlsx.xlsb",
"apachepoi_UncalcedRecord.xls.xlsb",
"apachepoi_UnionPtg.xls.xlsb",
"apachepoi_WORKBOOK_in_capitals.xls.xlsb",
"apachepoi_WeekNumFunctionTestCaseData.xls.xlsb",
"apachepoi_WeekNumFunctionTestCaseData2013.xls.xlsb",
"apachepoi_WithChart.xls.xlsb",
"apachepoi_WithChart.xlsx.xlsb",
//"apachepoi_WithChartSheet.xlsx.xlsb",
"apachepoi_WithCheckBoxes.xls.xlsb",
"apachepoi_WithConditionalFormatting.xls.xlsb",
"apachepoi_WithConditionalFormatting.xlsx.xlsb",
"apachepoi_WithDrawing.xlsx.xlsb",
"apachepoi_WithEmbeddedObjects.xls.xlsb",
"apachepoi_WithEmbeded.xlsx.xlsb",
"apachepoi_WithExtendedStyles.xls.xlsb",
"apachepoi_WithFormattedGraphTitle.xls.xlsb",
"apachepoi_WithHyperlink.xls.xlsb",
"apachepoi_WithMoreVariousData.xlsx.xlsb",
"apachepoi_WithTable.xlsx.xlsb",
"apachepoi_WithTextBox.xlsx.xlsb",
"apachepoi_WithTextBox2.xlsx.xlsb",
"apachepoi_WithThreeCharts.xls.xlsb",
"apachepoi_WithThreeCharts.xlsx.xlsb",
"apachepoi_WithTwoCharts.xls.xlsb",
"apachepoi_WithTwoCharts.xlsx.xlsb",
"apachepoi_WithTwoHyperLinks.xls.xlsb",
"apachepoi_WithVariousData.xlsx.xlsb",
"apachepoi_WrongFormulaRecordType.xls.xlsb",
"apachepoi_XRefCalc.xls.xlsb",
"apachepoi_XRefCalcData.xls.xlsb",
"apachepoi_atp.xls.xlsb",
"apachepoi_atp.xlsx.xlsb",
"apachepoi_blankworkbook.xls.xlsb",
"apachepoi_bug_42794.xls.xlsb",
//"apachepoi_chart_sheet.xlsx.xlsb",
"apachepoi_colwidth.xls.xlsb",
"apachepoi_comments.xls.xlsb",
"apachepoi_comments.xlsx.xlsb",
//"apachepoi_countblankExamples.xls.xlsb",
"apachepoi_countifExamples.xls.xlsb",
"apachepoi_dg-text.xls.xlsb",
"apachepoi_drawings.xls.xlsb",
"apachepoi_duprich1.xls.xlsb",
"apachepoi_duprich2.xls.xlsb",
"apachepoi_dvEmpty.xls.xlsb",
"apachepoi_empty.xls.xlsb",
"apachepoi_ex41187-19267.xls.xlsb",
"apachepoi_ex42564-21435.xls.xlsb",
"apachepoi_ex42564-21503.xls.xlsb",
"apachepoi_ex42564-elementOrder.xls.xlsb",
//"apachepoi_ex42570-20305.xls.xlsb",
"apachepoi_ex44921-21902.xls.xlsb",
"apachepoi_ex45046-21984.xls.xlsb",
"apachepoi_ex45582-22397.xls.xlsb",
"apachepoi_ex45672.xls.xlsb",
"apachepoi_ex45698-22488.xls.xlsb.pending",
"apachepoi_ex45978-extraLinkTableSheets.xls.xlsb",
"apachepoi_ex46548-23133.xls.xlsb",
"apachepoi_ex47747-sharedFormula.xls.xlsb",
"apachepoi_excel_with_embeded.xls.xlsb",
"apachepoi_excelant.xls.xlsb",
"apachepoi_externalFunctionExample.xls.xlsb",
"apachepoi_finance.xls.xlsb",
"apachepoi_headerFooterTest.xlsx.xlsb",
"apachepoi_intercept.xls.xlsb",
"apachepoi_mirrTest.xls.xlsb",
"apachepoi_missingFuncs44675.xls.xlsb",
"apachepoi_mortgage-calculation.xls.xlsb",
"apachepoi_multibookFormulaA.xls.xlsb",
"apachepoi_multibookFormulaB.xls.xlsb",
"apachepoi_namedinput.xls.xlsb",
"apachepoi_noHeaderFooter47244.xls.xlsb",
"apachepoi_ole2-embedding.xls.xlsb",
"apachepoi_overlapSharedFormula.xls.xlsb",
"apachepoi_password.xls.xlsb.pending",
"apachepoi_picture.xlsx.xlsb",
"apachepoi_rank.xls.xlsb",
"apachepoi_reordered_sheets.xlsx.xlsb",
"apachepoi_rk.xls.xlsb",
"apachepoi_sample.xlsx.xlsb",
"apachepoi_shared_formulas.xls.xlsb",
"apachepoi_shared_formulas.xlsx.xlsb",
"apachepoi_sheetProtection_allLocked.xlsx.xlsb",
"apachepoi_sheetProtection_not_protected.xlsx.xlsb",
"apachepoi_styles.xlsx.xlsb",
"apachepoi_sumifformula.xls.xlsb",
"apachepoi_sumifs.xls.xlsb",
"apachepoi_templateExcelWithAutofilter.xls.xlsb",
"apachepoi_testArraysAndTables.xls.xlsb",
"apachepoi_testNames.xls.xlsb",
"apachepoi_testRRaC.xls.xlsb",
"apachepoi_testRVA.xls.xlsb",
"apachepoi_text.xls.xlsb",
"apachepoi_unicodeNameRecord.xls.xlsb",
"apachepoi_workbookProtection_not_protected.xlsx.xlsb",
"apachepoi_workbookProtection_workbook_revision_protected.xlsx.xlsb",
"apachepoi_workbookProtection_workbook_structure_protected.xlsx.xlsb",
"apachepoi_workbookProtection_workbook_windows_protected.xlsx.xlsb",
"apachepoi_workbookProtection_worksheet_protected.xlsx.xlsb",
"apachepoi_xlsx-jdbc.xlsx.xlsb",
"apachepoi_yearfracExamples.xls.xlsb",
"comments_stress_test.xlsb",
"custom_properties.xlsb",
"formula_stress_test.xlsb",
"large_strings.xlsb.pending",
"merge_cells.xlsb",
"named_ranges_2011.xlsb",
"number_format.xlsb",
"pivot_table_named_range.xlsb",
"pivot_table_test.xlsb",
"rich_text_stress.xlsb",
"time_stress_test_1.xlsb.pending",
"xlsx-stream-d-date-cell.xlsb",
"BlankSheetTypes.xlsm",
"NumberFormatCondition.xlsm",
"apachepoi_45431.xlsm",
"apachepoi_47026.xlsm",
"apachepoi_47089.xlsm",
"apachepoi_ExcelWithAttachments.xlsm",
"number_format.xlsm",
"openpyxl_r_vba-test.xlsm",
"pivot_table_test.xlsm",
"AutoFilter.xlsx",
"LONumbers-2010.xlsx",
"LONumbers-2011.xlsx",
"LONumbers.xlsx",
"RkNumber.xlsx",
"apachepoi_45430.xlsx",
"apachepoi_45540_classic_Footer.xlsx",
"apachepoi_45540_classic_Header.xlsx",
"apachepoi_45540_form_Footer.xlsx",
"apachepoi_45540_form_Header.xlsx",
"apachepoi_45544.xlsx",
"apachepoi_46535.xlsx",
"apachepoi_46536.xlsx",
"apachepoi_47090.xlsx",
"apachepoi_47504.xlsx",
"apachepoi_47668.xlsx",
"apachepoi_47737.xlsx",
"apachepoi_47804.xlsx",
"apachepoi_47813.xlsx.pending",
"apachepoi_47862.xlsx",
"apachepoi_47889.xlsx",
"apachepoi_48495.xlsx",
"apachepoi_48539.xlsx",
"apachepoi_48703.xlsx",
"apachepoi_48779.xlsx",
"apachepoi_48923.xlsx",
"apachepoi_49156.xlsx",
"apachepoi_49273.xlsx",
"apachepoi_49325.xlsx",
"apachepoi_49609.xlsx",
"apachepoi_49783.xlsx",
"apachepoi_49872.xlsx",
"apachepoi_49928.xlsx",
"apachepoi_49966.xlsx",
"apachepoi_50096.xlsx",
"apachepoi_50299.xlsx",
"apachepoi_50784-font_theme_colours.xlsx",
"apachepoi_50786-indexed_colours.xlsx",
"apachepoi_50795.xlsx",
"apachepoi_50846-border_colours.xlsx",
"apachepoi_50867_with_table.xlsx",
"apachepoi_51222.xlsx",
"apachepoi_51470.xlsx",
"apachepoi_51585.xlsx.pending",
"apachepoi_51710.xlsx",
"apachepoi_51850.xlsx",
"apachepoi_51963.xlsx",
"apachepoi_52348.xlsx",
"apachepoi_52716.xlsx",
"apachepoi_53101.xlsx",
"apachepoi_53282.xlsx",
"apachepoi_53282b.xlsx",
"apachepoi_53568.xlsx",
"apachepoi_53734.xlsx",
"apachepoi_53798.xlsx",
"apachepoi_53798_shiftNegative_TMPL.xlsx",
"apachepoi_54071.xlsx",
"apachepoi_54084 - Greek - beyond BMP.xlsx",
"apachepoi_54206.xlsx",
"apachepoi_54288-ref.xlsx",
"apachepoi_54288.xlsx",
"apachepoi_54436.xlsx",
"apachepoi_54524.xlsx",
"apachepoi_54607.xlsx",
"apachepoi_55640.xlsx",
"apachepoi_55745.xlsx",
"apachepoi_55850.xlsx",
"apachepoi_55923.xlsx",
"apachepoi_55924.xlsx",
"apachepoi_55926.xlsx",
"apachepoi_55927.xlsx",
"apachepoi_56011.xlsx",
"apachepoi_56017.xlsx",
"apachepoi_56169.xlsx",
"apachepoi_56278.xlsx",
"apachepoi_AverageTaxRates.xlsx",
"apachepoi_Booleans.xlsx",
"apachepoi_BrNotClosed.xlsx",
"apachepoi_CustomXMLMapping-singleattributenamespace.xlsx",
"apachepoi_CustomXMLMappings-complex-type.xlsx",
"apachepoi_CustomXMLMappings.xlsx",
"apachepoi_CustomXmlMappings-inverse-order.xlsx",
"apachepoi_DataValidations-49244.xlsx",
"apachepoi_DateFormatTests.xlsx",
"apachepoi_ElapsedFormatTests.xlsx",
"apachepoi_ForShifting.xlsx",
"apachepoi_FormatChoiceTests.xlsx",
"apachepoi_FormatConditionTests.xlsx",
"apachepoi_Formatting.xlsx",
"apachepoi_FormulaEvalTestData_Copy.xlsx",
"apachepoi_GeneralFormatTests.xlsx",
"apachepoi_GroupTest.xlsx",
"apachepoi_InlineStrings.xlsx",
"apachepoi_NewlineInFormulas.xlsx",
"apachepoi_NumberFormatApproxTests.xlsx",
"apachepoi_NumberFormatTests.xlsx",
"apachepoi_RepeatingRowsCols.xlsx",
"apachepoi_SampleSS.xlsx",
"apachepoi_ShrinkToFit.xlsx",
"apachepoi_SimpleMultiCell.xlsx",
"apachepoi_SimpleWithComments.xlsx",
"apachepoi_Tables.xlsx",
"apachepoi_TextFormatTests.xlsx",
"apachepoi_TwoSheetsNoneHidden.xlsx",
"apachepoi_TwoSheetsOneHidden.xlsx",
"apachepoi_WithChart.xlsx",
"apachepoi_WithChartSheet.xlsx.pending",
"apachepoi_WithConditionalFormatting.xlsx",
"apachepoi_WithDrawing.xlsx",
"apachepoi_WithEmbeded.xlsx",
"apachepoi_WithMoreVariousData.xlsx",
"apachepoi_WithTable.xlsx",
"apachepoi_WithTextBox.xlsx",
"apachepoi_WithTextBox2.xlsx",
"apachepoi_WithThreeCharts.xlsx",
"apachepoi_WithTwoCharts.xlsx",
"apachepoi_WithVariousData.xlsx",
"apachepoi_atp.xlsx",
"apachepoi_chart_sheet.xlsx.pending",
"apachepoi_comments.xlsx",
"apachepoi_headerFooterTest.xlsx",
"apachepoi_picture.xlsx",
"apachepoi_reordered_sheets.xlsx",
"apachepoi_sample-beta.xlsx.pending",
"apachepoi_sample.xlsx",
"apachepoi_shared_formulas.xlsx",
"apachepoi_sheetProtection_allLocked.xlsx",
"apachepoi_sheetProtection_not_protected.xlsx",
"apachepoi_styles.xlsx",
"apachepoi_workbookProtection_not_protected.xlsx",
"apachepoi_workbookProtection_workbook_revision_protected.xlsx",
"apachepoi_workbookProtection_workbook_structure_protected.xlsx",
"apachepoi_workbookProtection_workbook_windows_protected.xlsx",
"apachepoi_workbookProtection_worksheet_protected.xlsx",
"apachepoi_xlsx-jdbc.xlsx",
"comments_stress_test.xlsx",
"custom_properties.xlsx",
"excel-reader-xlsx_data01.xlsx",
"excel-reader-xlsx_data02.xlsx",
"excel-reader-xlsx_error02.xlsx.pending",
"excel-reader-xlsx_error03.xlsx.pending",
"excel-reader-xlsx_error04.xlsx.pending",
"excel-reader-xlsx_error05.xlsx.pending",
"excel-reader-xlsx_error06.xlsx.pending",
"excel-reader-xlsx_error07.xlsx.pending",
"excel-reader-xlsx_error08.xlsx.pending",
"excel-reader-xlsx_inline01.xlsx",
"excel-reader-xlsx_libre01.xlsx",
"formula_stress_test.xlsx",
"interview.xlsx",
"issue.xlsx",
"jxls-core_formulaOneRow.xlsx",
"jxls-core_simple.xlsx",
"jxls-examples_stress1.xlsx",
"jxls-examples_stress2.xlsx",
"jxls-reader_departmentData.xlsx",
"large_strings.xlsx.pending",
"merge_cells.xlsx",
"mixed_sheets.xlsx",
"named_ranges_2011.xlsx",
"openpyxl_g_NameWithValueBug.xlsx",
"openpyxl_g_empty-no-string.xlsx",
"openpyxl_g_empty-with-styles.xlsx",
"openpyxl_g_empty.xlsx",
"openpyxl_g_empty_libre.xlsx",
"openpyxl_g_empty_no_dimensions.xlsx",
"openpyxl_g_empty_with_no_properties.xlsx.pending",
"openpyxl_g_guess_types.xlsx",
"openpyxl_g_libreoffice_nrt.xlsx",
"openpyxl_g_merge_range.xlsx",
"openpyxl_r_bigfoot.xlsx.pending",
"openpyxl_r_comments.xlsx",
"openpyxl_r_complex-styles.xlsx",
"openpyxl_r_conditional-formatting.xlsx",
"openpyxl_r_contains_chartsheets.xlsx.pending",
"openpyxl_r_date_1900.xlsx",
"openpyxl_r_date_1904.xlsx",
"openpyxl_r_formulae.xlsx",
"openpyxl_r_null_archive.xlsx.pending",
"openpyxl_r_null_file.xlsx.pending",
"pivot_table_named_range.xlsx",
"rich_text_stress.xlsx",
"roo_1900_base.xlsx",
"roo_1904_base.xlsx",
"roo_Bibelbund.xlsx",
"roo_Pfand_from_windows_phone.xlsx.pending",
"roo_bbu.xlsx",
"roo_boolean.xlsx",
"roo_borders.xlsx",
"roo_bug-numbered-sheet-names.xlsx.pending",
"roo_comments.xlsx",
"roo_datetime.xlsx",
"roo_emptysheets.xlsx",
"roo_file_item_error.xlsx",
"roo_formula.xlsx",
"roo_formula_string_error.xlsx",
"roo_link.xlsx",
"roo_named_cells.xlsx",
"roo_numbers-export.xlsx",
"roo_numbers1.xlsx",
"roo_numeric-link.xlsx",
"roo_only_one_sheet.xlsx",
"roo_paragraph.xlsx",
"roo_simple_spreadsheet.xlsx",
"roo_style.xlsx",
"roo_time-test.xlsx",
"roo_type_excel.xlsx.pending",
"roo_type_openoffice.xlsx.pending",
"roo_whitespace.xlsx",
"spreadsheet-parsexlsx_Test.xlsx",
"spreadsheet-parsexlsx_bug-10.xlsx",
"spreadsheet-parsexlsx_bug-11.xlsx",
"spreadsheet-parsexlsx_bug-12.xlsx",
"spreadsheet-parsexlsx_bug-13.xlsx",
"spreadsheet-parsexlsx_bug-14.xlsx",
"spreadsheet-parsexlsx_bug-15.xlsx",
"spreadsheet-parsexlsx_bug-2.xlsx",
"spreadsheet-parsexlsx_bug-3.xlsx",
"spreadsheet-parsexlsx_bug-4.xlsx",
"spreadsheet-parsexlsx_bug-5.xlsx",
"spreadsheet-parsexlsx_bug-6-2.xlsx",
"spreadsheet-parsexlsx_bug-6.xlsx",
"spreadsheet-parsexlsx_bug-7.xlsx",
"spreadsheet-parsexlsx_bug-8.xlsx",
"xlrd_merged_cells.xlsx",
"xlrd_reveng1.xlsx",
"xlrd_test_comments_excel.xlsx",
"xlrd_test_comments_gdocs.xlsx",
"xlrd_text_bar.xlsx",
"xlsx-stream-d-date-cell.xlsx",

"AutoFilter.ods",
"BlankSheetTypes.ods",
"apachepoi_SampleSS.ods",
"cell_style_simple.ods",
"formula_stress_test.ods",
"merge_cells.ods",
"number_format.ods",
"rich_text_stress.ods",
"roo_Bibelbund.ods",
"roo_Bibelbund1.ods",
"roo_advanced_header.ods",
"roo_bbu.ods",
"roo_boolean.ods",
"roo_borders.ods",
"roo_comments.ods",
"roo_datetime.ods",
"roo_dreimalvier.ods",
"roo_emptysheets.ods",
//"roo_encrypted-letmein.ods",
"roo_formula.ods",
"roo_hidden_sheets.ods",
"roo_html-escape.ods",
"roo_matrix.ods",
"roo_named_cells.ods",
"roo_numbers1.ods",
"roo_only_one_sheet.ods",
"roo_paragraph.ods",
"roo_ric.ods",
"roo_simple_spreadsheet.ods",
"roo_simple_spreadsheet_from_italo.ods",
"roo_style.ods",
"roo_time-test.ods",
"roo_type_excel.ods",
"roo_type_excelx.ods",
"roo_whitespace.ods",
"sushi.ods",

"apachepoi_חישוב_נקודות_זיכוי.xlsx.pending"
	].forEach(function(x) {
		it(x, x.substr(-8) == ".pending" ? null : function(done) {
			var oReq;
/* binary magic from stuk.github.io/jszip/test/browser-ie-test-utils.js */
			if(typeof window.XMLHttpRequest !== "undefined" || typeof XMLHttpRequest !== "undefined") oReq = new XMLHttpRequest();
			else oReq = new ActiveXObject("Microsoft.XMLHTTP");
			oReq.open("GET", '/test_files/' + x, true);
			if(oReq.overrideMimeType) oReq.overrideMimeType('text\/plain; charset=x-user-defined');
			if(typeof oReq.responseType !== "undefined") oReq.responseType = "arraybuffer";
			var f = function(e) {
				var wb, data, i;
				/*jshint -W009 */
				var arr = new Array();
				if(typeof oReq.responseType !== "undefined") {
					var arraybuffer = oReq.response;
					data = new Uint8Array(arraybuffer);
					for(i = 0; i != data.length; ++i) arr[i] = data[i];
					wb = (x.substr(-1) == "s" || x.substr(-1) == "l") ? XLS.read(arr, {type:'array'})
						: XLSX.read(arr.map(function(x) { return String.fromCharCode(x); }).join(""), {type:'binary'});
				} else {
					var binary = oReq.responseBody;
					var byteMapping = {};
					for ( i = 0; i < 256; i++ ) {
						for ( var j = 0; j < 256; j++ ) {
							byteMapping[ String.fromCharCode( i + (j << 8) ) ] = String.fromCharCode(i) + String.fromCharCode(j);
						}
					}
					var rawBytes = IEBinaryToArray_ByteStr(binary);
					var lastChr = IEBinaryToArray_ByteStr_Last(binary);
					data = rawBytes.replace(/[\s\S]/g, function( match ) { return byteMapping[match]; }) + lastChr;
					for(i = 0; i != data.length; ++i) arr[i] = data.charCodeAt(i) & 0xff;
					wb = (x.substr(-1) == "s" || x.substr(-1) == "l") ? XLS.read(arr, {type:'array'})
						: XLSX.read(arr.map(function(x) { return String.fromCharCode(x); }).join(""), {type:'binary'});
				}
				parsetest(x, wb);
				done();
			};
			try { oReq.onload = f; } catch(e) {
				oReq.onreadystatechange = function() {
					var i;
					if(oReq.readyState !== 4) return false;
					if(oReq.status != 200) throw "bad request: " + oReq.status;
					var binary = oReq.responseBody;
					var byteMapping = {};
					for ( i = 0; i < 256; i++ ) {
						for ( var j = 0; j < 256; j++ ) {
							byteMapping[ String.fromCharCode( i + (j << 8) ) ] = String.fromCharCode(i) + String.fromCharCode(j);
						}
					}
					var rawBytes = IEBinaryToArray_ByteStr(binary);
					var lastChr = IEBinaryToArray_ByteStr_Last(binary);
					var data = rawBytes.replace(/[\s\S]/g, function( match ) { return byteMapping[match]; }) + lastChr;
					var arr = [];
					for(i = 0; i != data.length; ++i) arr[i] = data.charCodeAt(i) & 0xff;
					wb = (x.substr(-1) == "s" || x.substr(-1) == "l") ? XLS.read(arr, {type:'array'})
						: XLSX.read(arr.map(function(x) { return String.fromCharCode(x); }).join(""), {type:'binary'});
					parsetest(x, wb);
					done();
				};
			}
			oReq.send();
		});
	});
});
